/*
 *  acpiconf.h - ACPI based kernel configuration 
 *
 *  Copyright (C) 2000 Intel Corp.
 *  Copyright (C) 2000 J.I. Lee <Jung-Ik.Lee@intel.com>
 */

#include <linux/init.h>

#define	PCI_MAX_BUS		0x100
#define	ACPI_STA_DEVICE_PRESENT	0x01

#ifdef	CONFIG_ACPI_KERNEL_CONFIG_DEBUG
#define	ACPI_CF_INITIALIZED()	(acpi_cf_initialized > 0)
#undef	dprintk
#define	dprintk(a)	printk a
#else
#define	ACPI_CF_INITIALIZED()	1
#undef	dprintk
#define	dprintk(a)
#endif


extern
void	__init
acpi_os_bind_osd(int acpi_phase);


static
ACPI_STATUS	__init
acpi_cf_get_prt (void **prts);


static
ACPI_STATUS	__init
acpi_cf_get_prt_callback (
	ACPI_HANDLE		handle,
	UINT32			level,
	void			*context,
	void			**retval
	);


static
void	__init
acpi_cf_add_to_pci_routing_tables (
	NATIVE_UINT		busnum,
	PCI_ROUTING_TABLE	*prt
	);


static
ACPI_STATUS	__init
acpi_cf_convert_prt_to_vectors (
	void				*prts,
	struct pci_vector_struct	**vectors,
	int				*num_pci_vectors
	);


void	__init
acpi_cf_cleanup ( void );

