/*****************************************************************************
 *****************************************************************************
Copyright (c) 2000 - 2001, Intel Corporation 
 
All rights reserved.
Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
 
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
 
 3. Neither the name of Intel Corporation nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.
 
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 *****************************************************************************
 ****************************************************************************/

/**********************************************************************
 *                                                                     *
 * INTEL CORPORATION                                                   *
 *                                                                     *
 * This software is supplied under the terms of the license included   *
 * above.  All use of this software must be in accordance with the     *
 * terms of that license.                                              *
 *                                                                     *
 * Module Name:  idiag_e1000.h                                         *
 *                                                                     *
 * Abstract:     Header file for data structure definition for common  *
 *               diagnostics support                                   *
 *                                                                     *
 **********************************************************************/

#ifndef _E1000_IDIAG_H
#define _E1000_IDIAG_H

#include "idiag_pro.h"
#include "idiag_e1000.h"

extern idiag_pro_stat_t e1000_DiagRegTest
(ADAPTER_STRUCT *Adapter, idiag_e1000_diag_reg_test_param_t *Param);

extern idiag_pro_stat_t e1000_DiagFifoTest
(ADAPTER_STRUCT *Adapter, idiag_e1000_diag_fifo_test_param_t *Param);

extern idiag_pro_stat_t e1000_DiagEepromTest
(ADAPTER_STRUCT *Adapter, idiag_e1000_diag_eeprom_test_param_t *Param);

extern idiag_pro_stat_t e1000_DiagIntrTest
(ADAPTER_STRUCT *Adapter, idiag_e1000_diag_intr_test_param_t *Param);

extern idiag_pro_stat_t e1000_DiagLoopbackTest
(ADAPTER_STRUCT *Adapter, idiag_e1000_diag_loopback_test_param_t *Param);

extern idiag_pro_stat_t e1000_DiagLinkTest
(ADAPTER_STRUCT *Adapter, idiag_e1000_diag_link_test_param_t *Param);

#endif
